import QtQuick 2.0

Item {
    //sized by qtubuntu

    Rectangle {
        id: launcherBackground
        anchors {
            left: parent.left
            top: parent.top
            bottom: parent.bottom
        }
        width: 180
        color: "grey"
        opacity: 0.3
    }

    ListModel {
        id: installedApplications
        ListElement {
            name: "Ski Safari"
            desktopFile: "ski-safari-mockapp"
        }
        ListElement {
            name: "Notes"
            desktopFile: "notes-app"
        }
        ListElement {
            name: "Clock"
            desktopFile: "ubuntu-clock-app"
        }
    }

    ListView {
        anchors.fill: launcherBackground
        model: applicationManager.mainStageApplications
        delegate: Rectangle {
            width: launcherBackground - 20
            height: width
            Image {
                anchors.fill: parent
                source: icon
            }
            MouseArea {
                anchors.fill: parent
                onClicked: {
                    applicationManager.focusApplication(handle)
                }
            }
        }
    }

    Row {
        id: iconList
        anchors {
            bottom: parent.bottom
            left: parent.left
            right: parent.right
        }
        height: 100
        spacing: 10
        Repeater {
            model: installedApplications
            delegate: Rectangle {
                width: (iconList.width - (installedApplications.count - 1)*iconList.spacing) / installedApplications.count
                height: iconList.height
                color: (index % 2) ? "yellow" : "pink"
                Text {
                    anchors.centerIn: parent
                    text: model.name
                    font.pointSize: 20
                }
                MouseArea {
                    anchors.fill: parent
                    onClicked: {
                        applicationManager.startProcess("/usr/share/applications/" + model.desktopFile + ".desktop");
                    }
                }
            }
        }

    }
}
