#ifndef DESKTOPFILEREADER_H
#define DESKTOPFILEREADER_H

#include <QString>
#include <QVector>

class DesktopFileReader {
public:
    DesktopFileReader(QString desktopFile);
    ~DesktopFileReader();

    QString file() const { return file_; }
    QString appId() const { return appId_; }
    QString name() const { return entries_[kNameIndex]; }
    QString comment() const { return entries_[kCommentIndex]; }
    QString icon() const { return entries_[kIconIndex]; }
    QString exec() const { return entries_[kExecIndex]; }
    QString stageHint() const { return entries_[kStageHintIndex]; }
    bool loaded() const { return loaded_; }

private:
    static const int kNameIndex = 0,
    kCommentIndex = 1,
    kIconIndex = 2,
    kExecIndex = 3,
    kStageHintIndex = 4,
    kNumberOfEntries = 5;

    bool loadDesktopFile(QString desktopFile);

    QString file_;
    QString appId_;
    QVector<QString> entries_;
    bool loaded_;
};

#endif // DESKTOPFILEREADER_H
