#include "initialsurfaceplacementstrategy.h"

#include "mir/shell/surface_creation_parameters.h"

InitialSurfacePlacementStrategy::InitialSurfacePlacementStrategy(std::shared_ptr<mir::graphics::Display> const& display_area)
  : display_area(display_area)
{
}

mir::shell::SurfaceCreationParameters
InitialSurfacePlacementStrategy::place(mir::shell::SurfaceCreationParameters const& request_parameters)
{
    using namespace mir::geometry;

    auto placed_parameters = request_parameters;
    placed_parameters.size = display_area->view_area().size;

    // position surface initially off-screen, until ready to be animated in
//    placed_parameters.top_left = Point{ X{display_area->view_area().size.width.as_int()}, Y{0}};

    return placed_parameters;
}
