#include "mirsurfacemanager.h"
#include "mirsurface.h"

#include "logging.h"

using namespace mir::shell;

MirSurfaceManager::MirSurfaceManager(QObject *parent)
    : QObject(parent)
{
}

MirSurfaceManager::~MirSurfaceManager()
{
    Q_FOREACH(auto surface, m_surfaces) {
        delete surface;
    }
    m_surfaces.clear();
}

void MirSurfaceManager::surfaceCreated(const std::shared_ptr<Surface> &surface)
{
    auto qmlSurface = new MirSurface(surface);
    m_surfaces.prepend(qmlSurface);

    Q_EMIT surfaceCreated(qmlSurface);
}
