#ifndef MIR_SURFACE_MANAGER_H
#define MIR_SURFACE_MANAGER_H

// std
#include <memory>

// Qt
#include <QObject>

class MirSurface;
namespace mir { namespace shell { class Surface; }}

class MirSurfaceManager : public QObject
{
    Q_OBJECT

public:
    MirSurfaceManager(QObject *parent = 0);
    ~MirSurfaceManager();

Q_SIGNALS:
    void surfaceCreated(MirSurface*);
//    void surfaceDestroyed(MirSurface*);
//    void surfaceResized(MirSurface*);
//    void fullscreenSurfaceChanged();

public Q_SLOTS:
    void surfaceCreated(std::shared_ptr<mir::shell::Surface> const& surface);

private:
    QList<MirSurface*> m_surfaces;
};

#endif // MIR_SURFACE_MANAGER_H
