#include "sessionauthorizer.h"
#include "logging.h"

SessionAuthorizer::SessionAuthorizer(std::shared_ptr<mir::shell::SessionManager> const& sessionManager, QObject *parent)
    :   QObject(parent)
{
    Q_UNUSED(sessionManager)
}

SessionAuthorizer::~SessionAuthorizer()
{
}

bool SessionAuthorizer::connection_is_allowed(pid_t pid, std::string const& name)
{
    DLOG("SessionAuthorizer::connection_is_allowed (this=%p, pid=%d", this, pid);

    QString authorizedName;
    Q_EMIT requestAuthorizationForSession(pid, authorizedName); // needs to block until authorizedName returned

    if (!authorizedName.isNull()) {
        name = authorizedName.toStdString();
        return true;
    }
    return false;
}
