#ifndef SESSIONAUTHORIZER_H
#define SESSIONAUTHORIZER_H

//std
#include <string>

// mir
#include <mir/frontend/session_authorizer.h>
#include <mir/shell/session_manager.h>

// Qt
#include <QObject>

class SessionAuthorizer : public QObject, public mir::frontend::SessionAuthorizer
{
    Q_OBJECT

public:
    SessionAuthorizer(std::shared_ptr<mir::shell::SessionManager> const& sessionManager, QObject *parent = 0);
    ~SessionAuthorizer();

    virtual bool connection_is_allowed(pid_t pid, std::string const& name) override;

Q_SIGNALS:
    // needs to be blocked queued signal which returns value for authorizedName
    void requestAuthorizationForSession(const quint64& pid, QString& authorizedName);
};

#endif // SESSIONAUTHORIZER_H
