#ifndef SESSIONLISTENER_H
#define SESSIONLISTENER_H

#include <QObject>

#include "mir/shell/session_listener.h"
#include "mir/shell/application_session.h"

class SessionListener : public QObject, public mir::shell::SessionListener
{
    Q_OBJECT
public:
    explicit SessionListener(QObject *parent = 0);
    ~SessionListener();

    void starting(std::shared_ptr<mir::shell::Session> const& session) override;
    void stopping(std::shared_ptr<mir::shell::Session> const& session) override;
    void focused(std::shared_ptr<mir::shell::Session> const& session) override;
    void unfocused() override;

Q_SIGNALS:
    void sessionStarting(std::shared_ptr<mir::shell::ApplicationSession> const& session);
    void sessionStopping(std::shared_ptr<mir::shell::ApplicationSession> const& session);
    void sessionFocused(std::shared_ptr<mir::shell::ApplicationSession> const& session);
    void sessionUnfocused();
};

#endif // SESSIONLISTENER_H
