#ifndef SHELLSERVERCONFIGURATION_H
#define SHELLSERVERCONFIGURATION_H

#include <QObject>
#include <mirserver/mir/default_server_configuration.h>

class SessionListener;
class SurfaceSource;

class ShellServerConfiguration : public QObject, public mir::DefaultServerConfiguration
{
    Q_OBJECT

    Q_PROPERTY(SessionListener* sessionListener READ sessionListener CONSTANT)
    Q_PROPERTY(SurfaceSource* surfaceSource READ surfaceSource CONSTANT)

public:
    ShellServerConfiguration(int argc, char const* argv[], QObject* parent = 0);
    ~ShellServerConfiguration();

    /* mir specific */
    std::shared_ptr<mir::shell::PlacementStrategy> the_shell_placement_strategy() override;
    std::shared_ptr<mir::shell::SessionListener> the_shell_session_listener() override;

    std::shared_ptr<mir::shell::SurfaceFactory> the_shell_surface_factory() override;
//    std::shared_ptr<mir::frontend::SessionAuthorizer> the_session_authorizer() override;

    /* qt specific */
    // getters
    SessionListener *sessionListener() const;
    SurfaceSource* surfaceSource() const;

protected:
    std::shared_ptr<SessionListener> m_sessionListener;
    std::shared_ptr<SurfaceSource> m_surfaceSource;
};

#endif // SHELLSERVERCONFIGURATION_H
