#include "surfacesource.h"

#include "logging.h"

namespace msh = mir::shell;

SurfaceSource::SurfaceSource(const std::shared_ptr<msh::SurfaceBuilder> &surfaceBuilder, QObject *parent)
    : QObject(parent)
    , msh::SurfaceSource(surfaceBuilder)
    , m_surfaceBuilder(surfaceBuilder)
{
    qRegisterMetaType<std::shared_ptr<msh::Surface>>("std::shared_ptr<mir::shell::Surface>");
}

SurfaceSource::~SurfaceSource()
{
}

std::shared_ptr<msh::Surface>
SurfaceSource::create_surface(
        msh::SurfaceCreationParameters const& params,
        mir::frontend::SurfaceId id,
        std::shared_ptr<mir::events::EventSink> const& sink)
{
    DLOG("SurfaceSource::create_surface");
    std::shared_ptr<msh::Surface> mirSurface = msh::SurfaceSource::create_surface(params, id, sink);

    Q_EMIT surfaceCreated(mirSurface);
    return mirSurface;
}
