#ifndef SURFACESOURCE_H
#define SURFACESOURCE_H

#include <QObject>

#include "mir/shell/surface.h"
#include "mir/shell/surface_source.h"
#include "mir/shell/surface_builder.h"

Q_DECLARE_METATYPE(std::shared_ptr<mir::shell::Surface>)

class SurfaceSource : public QObject, public mir::shell::SurfaceSource
{
    Q_OBJECT

public:
    SurfaceSource(std::shared_ptr<mir::shell::SurfaceBuilder> const& surfaceBuilder, QObject *parent = 0);
    ~SurfaceSource();

    //Called by Mir server
    std::shared_ptr<mir::shell::Surface> create_surface(
            mir::shell::SurfaceCreationParameters const& params,
            mir::frontend::SurfaceId id,
            std::shared_ptr<mir::events::EventSink> const& sink) override;

Q_SIGNALS:
    void surfaceCreated(std::shared_ptr<mir::shell::Surface> const& surface);

private:
    const std::shared_ptr<mir::shell::SurfaceBuilder> m_surfaceBuilder;
};

#endif // SURFACESOURCE_H
